]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
79664822df9f09d0c613afe1df1dc6c7ffd30859
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
35 %__gtkdocize            gtkdocize --copy
36 %__intltoolize          intltoolize --copy --force
37 %__libtoolize           libtoolize --copy --force
38
39 #       The number of cvs changelog entries kept when building package.
40 %_buildchangelogtruncate 20
41
42 %dependencytracking     %{nil}
43
44 #       Relations between package names that cause dependency loops
45 #       with legacy packages that cannot be fixed. Relations are
46 #       specified as
47 #               p>q
48 #       where package p has a Requires: on something that package q Provides:
49 #
50 # XXX   Note: that there cannot be any whitespace within the string "p>q",
51 #       and that both p and q are package names (i.e. no version/release).
52 %_dependency_whiteout   %{nil}
53
54
55 #-----------------------------------------------------------------
56 #
57 # (re)definition of %{rpm*flags} with %filterout_* support
58 # Requires:             awk
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i in I) {  A=0;                    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
116  %{?__cc:CC="%{__cc}" ; export CC ; } \
117  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
118  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
119         --host=%{_target_platform} \
120         --prefix=%{_prefix} \
121         --exec-prefix=%{_exec_prefix} \
122         --bindir=%{_bindir} \
123         --sbindir=%{_sbindir} \
124         --sysconfdir=%{_sysconfdir} \
125         --datadir=%{_datadir} \
126         --includedir=%{_includedir} \
127         --libdir=%{_libdir} \
128         --libexecdir=%{_libexecdir} \
129         --localstatedir=%{_localstatedir} \
130         --sharedstatedir=%{_sharedstatedir} \
131         --mandir=%{_mandir} \
132         --infodir=%{_infodir} \
133         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
134         %{dependencytracking} \
135 }
136
137 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
138 %__cmake        /usr/bin/cmake
139 %cmake { \
140 CC="%{__cc}" \
141 CXX="%{__cxx}" \
142 CFLAGS="%{rpmcflags}" \
143 CXXFLAGS="%{rpmcxxflags}" \
144 %{__cmake} \
145 }
146
147 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
148 %__scons        /usr/bin/scons
149 %scons { \
150 %{__scons} \
151 }
152
153 # waf. see waf.spec
154 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
155 %__waf  /usr/bin/waf
156 %waf { \
157 CC="%{__cc}" \
158 CXX="%{__cxx}" \
159 CPP="%{__cpp}" \
160 CFLAGS="%{rpmcflags}" \
161 CXXFLAGS="%{rpmcxxflags}" \
162 %{__waf} \
163 }
164
165 #----------------------------------------------------------------
166 %global configure_cache 0
167 %configure_cache_file   %{buildroot}.configure.cache
168
169 %configure {./configure \
170         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
171         CFLAGS="${CFLAGS:-%rpmcflags}" \
172         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
173         FFLAGS="${FFLAGS:-%rpmcflags}" \
174         CPPFLAGS="${CPPFLAGS:-}" \
175         %{?__cc:CC="%{__cc}"} \
176         %{?__cxx:CXX="%{__cxx}"} \
177         --host=%{_target_platform} \
178         --build=%{_target_platform} \
179         --prefix=%{_prefix} \
180         --exec-prefix=%{_exec_prefix} \
181         --bindir=%{_bindir} \
182         --sbindir=%{_sbindir} \
183         --sysconfdir=%{_sysconfdir} \
184         --datadir=%{_datadir} \
185         --includedir=%{_includedir} \
186         --libdir=%{_libdir} \
187         --libexecdir=%{_libexecdir} \
188         --localstatedir=%{_localstatedir} \
189         --sharedstatedir=%{_sharedstatedir} \
190         --mandir=%{_mandir} \
191         --infodir=%{_infodir} \
192         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
193         %{dependencytracking} \
194         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
195 }
196
197 # ------------------------------------------------------------------------
198 # Overloading of some basic macros
199 %prep \
200 %%prep\
201 export LC_ALL=C\
202 export LANG=C\
203 unset LINGUAS ||:\
204 unset LANGUAGE ||:\
205 unset LC_MESSAGES ||:\
206 unset DISPLAY ||:\
207 %{nil}
208
209 %build %%build\
210 export LC_ALL=C\
211 export LANG=C\
212 unset LINGUAS ||:\
213 unset LANGUAGE ||:\
214 unset LC_MESSAGES ||:\
215 unset DISPLAY ||:\
216 %{nil}
217
218 %install \
219 %if 0%{?_enable_debug_packages}\
220 %{?buildsubdir:%{debug_package}}\
221 %endif\
222 %%install\
223 export LC_ALL=C\
224 export LANG=C\
225 unset LINGUAS ||:\
226 unset LANGUAGE ||:\
227 unset LC_MESSAGES ||:\
228 unset DISPLAY ||:\
229 %{nil}
230
231 # Location of autoconf macros
232 %_aclocaldir    %(aclocal --print-ac-dir)
233
234 # Location of omf files
235 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
236
237 # Location of pkgconfig files
238 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
239
240 # Location of desktop files
241 %_desktopdir    /usr/share/applications
242 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
243
244 # Location of pixmaps for applnk/desktop files
245 %_pixmapsdir    /usr/share/pixmaps
246
247 # Location of themable icons for applnk/desktop files
248 %_iconsdir      /usr/share/icons
249
250 # Location of fonts directories
251 %_fontsdir      /usr/share/fonts
252
253 # Location of Gtk and associated libraries documentation
254 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
255
256 # Location of KDE documentation
257 %_kdedocdir     %{_defaultdocdir}/kde/HTML
258
259 # unsermake script
260 %__unsermake /usr/share/unsermake/unsermake
261
262 # Current date
263 %date           %(LC_ALL="C" date +"%a %b %d %Y")
264
265 # Example files, programs, scripts...
266 %_examplesdir   /usr/src/examples
267
268 # Alternative kernel type/version
269 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
270
271 # The directory holding Linux kernel sources
272 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
273
274 # If non-empty "debug" macro defined, add "dbg" suffix to release number
275 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
276
277 # Requires name = version-release
278 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
279
280 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
281 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
282 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
283 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
284
285 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
286 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
287
288 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
289
290 # kernel version-release handling
291 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
292 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
293 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
294 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
295 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
296
297 # sgml macros
298 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
299 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
300 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
301 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
302 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
303 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
304 %docbook_sgmlcat_fix() { for l in \
305 '' \
306 '  -- default decl --' \
307 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
308 '  -- hacks for opensp --' \
309 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
310 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
311 '' \
312 ; do echo $l; done >> %1 \
313 }
314
315 # minimum file size needed for compressed documents.
316 # just smaller files than this get larger when compressed.
317 # some stats:
318 # - 0 byte file compressed was 25 bytes .gz
319 # - 39 byte file was compressed as 57
320 # - with test/test.spec@man 158 byte file was compressed also 158
321 %_min_compress_bytes    159
322
323 #-----------------------------------------------------------------
324 # find and gzip all files in %{_mandir} and %{infodir}
325 #
326 # Requires: xargs, find
327 #
328 #%no_install_post_compress_docs 1
329 %__spec_install_post_compress_docs { \
330 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
331         for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
332                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
333                         echo "Compress $(basename $i) pages: $i"; \
334                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
335                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
336                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
337                 fi; \
338         done; \
339 }; __spec_install_post_compress_docs } }
340
341 #-----------------------------------------------------------------
342 # Strip executable binaries and shared object files
343 #
344 # Requires: find, awk, strip, cut, xargs
345 #
346 #%no_install_post_strip 1
347 %__spec_install_post_strip {%{!?debug: \
348 %{!?no_install_post_strip:__spec_install_post_strip() { \
349 if [ -d "$RPM_BUILD_ROOT" ]; then \
350         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
351         if [ -z "$filelist" ]; then \
352                 return; \
353         fi; \
354         filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
355         elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
356         elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
357         archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
358         if [ -n "$elfexelist" ]; then \
359                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
360                 chmod u+w $elfexelist; \
361                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
362                 echo "DONE"; \
363         fi; \
364         if [ -n "$elfsharedlist" ]; then \
365                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
366                 chmod u+w $elfsharedlist; \
367                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
368                 echo "DONE"; \
369         fi; \
370         if [ -n "$archiveslist" ]; then \
371                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
372                 chmod u+w $archiveslist; \
373                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
374                 echo "DONE"; \
375         fi; \
376 fi; }; __spec_install_post_strip } } }
377
378 #-----------------------------------------------------------------
379 # remove all RPATH from executable binaries and shared object files
380 #
381 # Requires: find, awk, cut, xargs, chrpath, uname
382 #
383 #%no_install_post_chrpath       1
384 %__spec_install_post_chrpath {%{!?debug: \
385 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
386 if [ -d "$RPM_BUILD_ROOT" ]; then \
387         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
388         if [ -n "$files" ]; then \
389                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
390         fi
391         #"
392         if [ -n "$objs" ]; then \
393                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
394                 echo "$objs" | \
395                 while read file; do \
396                         rpath= ; \
397                         chmod u+w "$file"; \
398                         for dir in `chrpath -l "$file" | \
399                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
400                                         case $dir in \
401                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
402                                                 echo "remove-rpath: $dir in $file"; \
403                                                 ;; \
404                                         * ) \
405                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
406                                                 else rpath="$rpath:$dir" ; fi ; \
407                                                 ;; \
408                                         esac ; \
409                         done ; \
410                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
411                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
412                 done; \
413         fi; \
414 fi; }; __spec_install_post_chrpath } } }
415
416 #-----------------------------------------------------------------
417 # Find and gzip all kernel modules
418 #
419 # Requires: find
420 #
421 #%no_install_post_compress_modules      1
422 %__spec_install_post_compress_modules { \
423 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
424         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
425                 echo "Compress kernel modules"; \
426                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
427                 echo "$q" | xargs -r %{__gzip} -9nf; \
428                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
429                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
430                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
431         fi; \
432 }; __spec_install_post_compress_modules } }
433
434 # Remove common Perl files we don't package
435 %__spec_install_post_perl_clean {\
436 %{!?no_install_post_perl_clean: \
437 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
438 } }
439
440 #-----------------------------------------------------------------
441 # Update GConf2 schemas
442 #
443 # Requires: GConf2
444 #
445 %gconf_schema_install() \
446         umask 022; \
447         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
448         %{nil}
449
450 %gconf_schema_uninstall() \
451 if [ $1 = 0 ]; then \
452         umask 022; \
453         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
454 fi \
455 %{nil}
456
457 #-----------------------------------------------------------------
458 # Update desktop MIME database
459 # requires: desktop-file-utils
460 #
461 %update_desktop_database_post() {{ \
462         umask 022; \
463         /usr/bin/update-desktop-database -q; \
464 }}
465
466 %update_desktop_database_postun() {{ \
467 if [ $1 = 0 ]; then \
468         umask 022; \
469         /usr/bin/update-desktop-database -q; \
470 fi \
471 }}
472
473 #-----------------------------------------------------------------
474 # Update shared MIME info database
475 # requires: shared-mime-info
476 #
477 %update_mime_database() {{ \
478         umask 022; \
479         /usr/bin/update-mime-database %{_datadir}/mime; \
480 }}
481
482 #-----------------------------------------------------------------
483 # Update icon cache
484 # requires: gtk+
485 #
486 %update_icon_cache() {{ \
487         umask 022; \
488         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
489 }}
490
491 #-----------------------------------------------------------------
492 # Update scrollkeeper database
493 # requires: scrollkeeper
494 #
495 %scrollkeeper_update_post() \
496         /usr/bin/scrollkeeper-update -q; \
497         %{nil}
498
499 %scrollkeeper_update_postun() \
500 if [ $1 = 0 ]; then \
501         /usr/bin/scrollkeeper-update -q; \
502 fi \
503 %{nil}
504
505 #-----------------------------------------------------------------
506 # post %install sequence:
507 # - autodeps exceptions
508 # - compress all man and info pages,
509 # - strip all ELF executables and ELF shared objects if not %debug.
510 # - compress kernel modules if any
511
512 ###################################################################
513 # Requires/Provides automation
514 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
515 #
516 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
517 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
518 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
519 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
520 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
521 #%_noautocompressdoc    %{nil}
522 #
523 %_missing_doc_files_terminate_build     1%{nil}
524 %_unpackaged_files_terminate_build      %{nil}
525 # (X)emacs support
526 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
527 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
528 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
529
530 %__php_provides %{nil}
531 %__php_requires %{nil}
532 %__perl_provides %{nil}
533 %__perl_requires %{nil}
534 %__mono_provides %{nil}
535 %__mono_requires %{nil}
536
537 # Perl specific macro definitions.
538 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
539 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
540 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
541 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
542 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
543 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
544
545 # Ruby
546 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
547 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
548 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
549 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
550 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
551 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
552 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
553 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
554
555 %php_pear_dir           /usr/share/pear
556 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
557 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
558
559 # directory where php includes are installed on system.
560 %__php_includedir               /usr/include/php
561 # extract php/zend api versions
562 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
563 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
564 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
565 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
566 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
567 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
568 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
569
570 # helper macro
571 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
572
573 # macros for public use
574 # for php extensions (php-pecl)
575 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
576 %{__php_api_requires zend_module_api} \
577 %{__php_api_requires -v %php_major_version debug php_debug} \
578 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
579
580 # for zend extensions
581 %requires_zend_extension %{__php_api_requires zend_module_api} \
582 %{__php_api_requires zend_extension_api} \
583 %{__php_api_requires -v %php_major_version debug php_debug} \
584 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
585
586 # for php pdo modules (php-pecl-PDO_*)
587 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
588
589 # for using PHP post scripts. for PHP >= 5.0
590 %php_webserver_restart \
591 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
592 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
593 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
594         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
595         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
596                 %service -q php-fcgi restart \
597         fi \
598 fi \
599 %{nil}
600
601 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
602 %php4_webserver_restart \
603 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
604 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
605 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
606         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
607         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
608                 %service -q php-fcgi restart \
609         fi \
610 fi \
611 %{nil}
612
613 # Python specific macro definitions.
614 # python main version
615 %py_ver                 %(python -c "import sys; print sys.version[:3]")
616
617 # directories
618 %py_prefix              %(python -c "import sys; print sys.prefix")
619 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
620 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
621 %py_incdir              /usr/include/python%{py_ver}
622 %py_sitedir             %{py_libdir}/site-packages
623 %py_sitescriptdir %{py_scriptdir}/site-packages
624 %py_dyndir              %{py_libdir}/lib-dynload
625
626 # pure python modules compilation
627 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
628
629 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
630
631 # Software written in Python language require Python with main version
632 %pyrequires_eq() Requires:      %1
633
634 # Hardlink binary identical .pyc and .pyo files
635 # (idea by glen <at> pld-linux <dot> org)
636 %__spec_install_post_py_hardlink {\
637 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
638 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
639         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
640         if cmp -s "$a" "$b"; then \
641                 ln -f "$a" "$b"; \
642         fi; \
643 done \
644 }; __spec_install_post_py_hardlink } }
645
646 # remove python sources, so that check-files won't complain
647 # (idea by glen <at> pld-linux <dot> org)
648 %py_postclean() \
649 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
650  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
651 done \
652 %{nil}
653
654 # depmod macro
655 %depmod() { \
656 umask 022; \
657 if [ -e /boot/System.map-%1 ]; then \
658         /sbin/depmod -a -F /boot/System.map-%1 %1; \
659 else \
660         if [ -e /boot/System.map ]; then \
661                 /sbin/depmod -a -F /boot/System.map %1; \
662         else \
663                 /sbin/depmod -a %1; \
664         fi \
665 fi; \
666 }
667
668 # XMMS specific macros
669 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
670 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
671 %xmms_version                   %(xmms-config --version 2>/dev/null)
672 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
673 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
674 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
675 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
676 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
677 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
678 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
679
680 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
681
682 # user/group checking macros
683 #
684 # Usage:
685 #       %userremove myuser
686 #
687 %userremove     /usr/lib/rpm/user_group.sh user del
688 %groupremove    /usr/lib/rpm/user_group.sh group del
689 #
690 # Usage:
691 #       if %usertestrm myuser; then
692 #               /usr/sbin/userdel -r myuser
693 # Note:
694 #       use these macros only if you need to call userdel/groupdel with
695 #       a non-standard option or take an extra action; otherwise use the
696 #       %userremove/%groupremove macros
697 #
698 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
699 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
700 # user group membership management macros
701 #
702 # Usage:
703 #       %addusertogroup myuser agroup
704 #
705 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
706
707 # banner support (useful in {pre,post}{,un} and triggers)
708 #
709 # Usage:
710 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
711 # the banner text, the banner text
712 # the banner text, and following line
713 #EOF
714 # You can use any form of here-document, <<'EOF' <<-EOT will do.
715 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
716 #
717 # -a   - append to the banner
718 # -e   - send to stderr instead of stdout
719 # -n   - no show banner (overrides -t)
720 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
721 %banner(aent:)  \
722 RPM_SCRIPTVERBOSITY=5 \
723 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
724 if [ -x /usr/bin/banner.sh ]; then \
725         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
726 else \
727         CMD="cat%{-e: >&2}" \
728 fi \
729 eval $CMD %2%{?3: %3} \
730 %nil
731
732 # useradd/groupadd macros
733 # Author: Elan Ruusamäe <glen@pld-linux.org>
734 #
735 # Usage:
736 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
737 #   [-g initial_group] [-G group[,...]] login
738 #
739 #  -u uid. REQUIRED
740 #  -g gid/group. REQUIRED
741 #  -s defaults to /bin/false
742 #  -d defaults to /usr/share/empty
743 #  -c No default
744 #  -r is accepted but ignored (it's always set)
745 #  -k skeleton dir. defaults to /usr/share/empty
746 # rpm specific flags
747 #  -P package name. defaults to %{name}
748 #
749 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
750 %{!-u:%{error:useradd: Required argument -u missing}} \
751 %{!-g:%{error:useradd: Required argument -g missing}} \
752 %{!?1:%{error:useradd: Required parameter login missing}} \
753 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
754         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
755                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
756                 exit 1 \
757         fi \
758 else \
759         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
760         /usr/sbin/useradd \\\
761                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
762                 -u %{-u*} \\\
763                 -r \\\
764                 -d %{-d*}%{!-d:/usr/share/empty} \\\
765                 -s %{-s*}%{!-s:/bin/false} \\\
766                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
767                 -g %{-g*} \\\
768                 %{-M} \\\
769                 %{-G:-G %{-G*}} \\\
770                 %{expand:%{%{#}}} 1>&2 || exit $? \
771         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
772 fi;
773
774 # Usage:
775 #   %groupadd [-P package] [-g gid] group
776 #
777 # -g gid. REQUIRED
778 #
779 # Sample:
780 #   %groupadd -P %{name}-base -g %{gid} %{name}
781
782 %groupadd(g:P:rfo)      \
783 %{!-g:%{error:groupadd: Required argument -g missing}} \
784 %{!?1:%{error:groupadd: Required parameter group missing}} \
785 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
786         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
787                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
788                 exit 1 \
789         fi \
790 else \
791         echo "Adding group %{1} GID=%{-g*}." \
792         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
793         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
794 fi;
795
796 # apache_config_{install/uninstall} macros *DEPRECATED*
797 # Author: Elan Ruusamäe <glen@pld-linux.org>
798 #
799 # You should use webapp macros instead. these are here until single piece of
800 # them is gone from specs ;)
801 #
802 # The config is installed/removed inside trigger, this means that you can any
803 # time install apache1 or apache package and the configuration file is updated.
804 # if you don't need the config for various reason for specific apache, just
805 # remove the symlink from apache config directory. the trigger will not put the
806 # config again to that version of apache. In other words the config is linked
807 # to apache config directory on first install of PACKAGE or apache.
808 #
809 # should be called in trigger body:
810 #  %triggerin -- apache1 >= 1.3.33-2
811 #  %apache_config_install -v 1
812 #
813 # Add package's apache config to apache config.
814 #
815 # Usage:
816 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
817 #
818 #  -v REQUIRED: specify apache version. can be 1 or 2.
819 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
820 #  -n OPTIONAL: specify config "slot". defaults to 99
821 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
822 #
823 # Internal macros. don't use ;).
824 # expands apache config dir by apache version at build time.
825 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
826 # expands apache service name by apache version at build time.
827 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
828
829 %apache_config_install(fv:c:n:) \
830 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
831 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
832 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
833         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
834 fi\
835 # reload apache if the config symlink is there\
836 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
837         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
838         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
839                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
840         fi\
841 fi\
842 %{nil}
843
844 # Remove package's apache config from apache config.
845 #
846 # Usage:
847 #   %apache_config_uninstall -v {1|2} -n 99
848 #
849 #  -v REQUIRED: specify apache version. can be 1 or 2.
850 #  -n OPTIONAL: specify config "slot". defaults to 99
851 %apache_config_uninstall(v:n:) \
852 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
853 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
854 # remove link if either of the packages are gone \
855 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
856         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
857                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
858                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
859                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
860                 fi \
861         fi \
862 fi \
863 %{nil}
864
865 # webapp macros
866 # Author: Elan Ruusamäe <glen@pld-linux.org>
867 #
868 # The config is installed/removed inside trigger, this means that you can any
869 # time install apache1/apache/lighttpd package and the configuration file is
870 # updated. if you don't need the config for various reason for specific
871 # webserver, just remove the symlink from config directory using webapp
872 # program. the trigger will not recreate the symlink on upgrades. In other
873 # words the config is linked to webserver config directory on first install of
874 # PACKAGE or WEBSERVER.
875 #
876 # Add package's webserver config to webserver webapps dir.
877 # Usage:
878 #   %webapp_register WEBSERVER WEBAPP
879 #
880 %webapp_register() \
881 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
882 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
883         /usr/sbin/webapp register %1 %2\
884 fi\
885 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
886 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
887         %{expand:%service -q %%1 reload}\
888 fi\
889 %{nil}
890
891 # Remove package's config from webserver webapps dir.
892 # Usage:
893 #   %webapp_register [-f] WEBSERVER WEBAPP
894 %webapp_unregister(f) \
895 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
896 # remove link if either of the packages are gone \
897 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
898         /usr/sbin/webapp unregister %1 %2\
899         %{expand:%service -q %%1 reload}\
900 fi \
901 %{nil}
902
903 # see browser-plugins.spec / template-browser-plugin.spec
904 # Author: Elan Ruusamäe <glen@pld-linux.org>
905 %nsplugin_install(d:f) { \
906 # create link if it's first install of either of the packages \
907 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
908 ( \
909 %( \
910         for file in %{*}; do \
911                 echo echo Installing $file to %{-d*}; \
912                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
913         done ) \
914 ) | ( %banner -t 5 -e %{name}-in ); fi; \
915 }
916
917 %nsplugin_uninstall(d:) { \
918 # remove link if either of the packages are gone \
919 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
920 ( \
921 %( \
922         for file in %{*}; do \
923                 echo echo Removing $file from %{-d*}; \
924                 echo "rm -f %{-d*}/$file;"; \
925         done ) \
926 ) | ( %banner -t 5 -e %{name}-un ); fi; \
927 }
928
929 # service macro.
930 # Author: Elan Ruusamäe <glen@pld-linux.org>
931 #
932 # calls usual service restart on package %post, but skips the restart if
933 # administrator has disabled automatic service restarts in either global
934 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
935 #
936 # Usage:
937 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
938 #
939 #  -q be silent when service isn't started (for scriplets restaring other package's services)
940 #
941 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
942
943
944 # java macros. based on jpackage macros.java
945 %_jvmdir                %{_libdir}/jvm
946 %_jvmjardir             %{_libdir}/jvm-exports
947 %_jvmprivdir            %{_libdir}/jvm-private
948 %_jvmlibdir             %{_libdir}/jvm
949 %_jvmdatadir            %{_datadir}/jvm
950 %_jvmsysconfdir         %{_sysconfdir}/jvm
951 # FIXME: are these used?
952 %_jvmcommonlibdir       %{_libdir}/jvm-common
953 %_jvmcommondatadir      %{_datadir}/jvm-common
954 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
955 %_jnidir                %{_libdir}/java
956 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
957
958 %ant                    JAVA_HOME=%{java_home} ant
959 %jar                    %{java_home}/bin/jar
960 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
961 %javac                  %{java_home}/bin/javac
962 %javadoc                %{java_home}/bin/javadoc
963
964 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
965
966 %jpackage_script() \
967 install -d $RPM_BUILD_ROOT%{_bindir}\
968 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
969 #!/bin/sh\
970 #\
971 # %{name} script\
972 # JPackage Project <http://www.jpackage.org/>\
973 \
974 # Source functions library\
975 . %{_javadir}-utils/java-functions\
976 \
977 # Source system prefs\
978 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
979     . %{_sysconfdir}/java/%{name}.conf\
980 fi\
981 \
982 # Source user prefs\
983 if [ -f $HOME/.%{name}rc ]; then\
984     . $HOME/.%{name}rc\
985 fi\
986 \
987 # Configuration\
988 MAIN_CLASS=%1\
989 BASE_FLAGS=%2\
990 BASE_OPTIONS=%3\
991 BASE_JARS="%(echo %4 | tr ':' ' ')"\
992 \
993 # Set parameters\
994 set_jvm\
995 set_classpath $BASE_JARS\
996 set_flags $BASE_FLAGS\
997 set_options $BASE_OPTIONS\
998 \
999 # Let's start\
1000 run "$@"\
1001 EOF
1002
1003 # PEAR install macros
1004 # Author: Elan Ruusamäe <glen@pld-linux.org>
1005 #
1006 # Usage:
1007 #       %%pear_package_setup [-a #] [-n FMT]
1008 #
1009 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1010 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1011 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1012 #
1013 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1014 # destination hierarchy. you should copy the tree to buildroot after
1015 # patching/reorganizing with %%pear_package_install.
1016 #
1017 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1018 # line endings.
1019 #
1020 # the pear install process output is recorded to install.log, you should put it
1021 # to %%doc for later debug or just for information.
1022 #
1023 # additionally additional-packages.txt is produced if it was detected that the
1024 # package has optional dependencies. the file format is suitable of displaying
1025 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1026 # automatically added for this file.
1027
1028
1029 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1030 %__pear_install_log \
1031 tee install.log \
1032 # make post message of optional packages \
1033 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1034 if [ -s optional-packages.txt ]; then \
1035         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1036 else \
1037         rm -f optional-packages.txt \
1038 fi \
1039 %{nil}
1040
1041 # command invoking pear cli
1042 %__pear /usr/bin/pear
1043
1044 # the main macro.
1045 # using this macro will append optional-packages.txt to the nocompressdoc list
1046 # as it's displayed to user after package install. and adding additional gzip
1047 # dep is just waste ;)
1048 %pear_package_setup(a:n:z) \
1049 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1050 %define builddir %{_builddir}/%{srcdir} \
1051 %setup -q -c -T -n %{srcdir} \
1052 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1053 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1054 %__pear \\\
1055         -c pearrc \\\
1056         -d doc_dir=/docs \\\
1057         -d php_dir=%{php_pear_dir} \\\
1058         -d bin_dir=%{_bindir} \\\
1059         -d data_dir=%{php_pear_dir}/data \\\
1060         -d test_dir=%{php_pear_dir}/tests \\\
1061         install \\\
1062         --packagingroot=%{builddir} \\\
1063         --offline \\\
1064         --nodeps \\\
1065         %{-f:--force} \\\
1066         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
1067 %{-z:cd ..} \
1068 cat %{-z:$_N/}.install.log | %__pear_install_log \
1069 \
1070 # undos sources \
1071 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1072 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1073 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1074 %{nil}
1075
1076 # copies exctracted PEAR package structure to buildroot.
1077 # also copies PEAR registry file.
1078 # please use this macro, for future extensions being possible.
1079 %pear_package_install() \
1080 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1081 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1082 # help the developer out a little: \
1083 if [ -f _noautoreq ]; then \
1084         echo "AutoReqdep detected:" \
1085         echo "_noautoreq $(cat _noautoreq)" \
1086 fi \
1087 %{nil}
1088
1089
1090 # Register OpenLDAP schema.
1091 # Author: Elan Ruusamäe <glen@pld-linux.org>
1092 #
1093 # Usage:
1094 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1095 #
1096 #  -d specify dependant schemas, separated by comma
1097 #
1098 %openldap_schema_register(d:) \
1099 for schema in %*; do \
1100         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1101                 %{__sed} -i -e " \
1102                         /^include.*local.schema/{ \
1103                                 iinclude\\t     $schema\
1104                         } \
1105                 " /etc/openldap/slapd.conf \
1106         fi \
1107 done \
1108 # enable dependant schemas \
1109 if [ "%{-d*}" ]; then \
1110         %{__sed} -i -e ' \
1111         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1112                 s/^#// \
1113         }' /etc/openldap/slapd.conf \
1114 fi \
1115 %{nil}
1116
1117 # Unregister OpenLDAP schema.
1118 # Author: Elan Ruusamäe <glen@pld-linux.org>
1119 #
1120 # Usage:
1121 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1122 #
1123 %openldap_schema_unregister() \
1124 for schema in %*; do \
1125         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1126                 %{__sed} -i -e " \
1127                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1128                 # for symmetry it would be nice if we disable enabled schemas in post, \
1129                 # but we really can not do that, it would break something else. \
1130                 " /etc/openldap/slapd.conf \
1131         fi \
1132 done \
1133 %{nil}
1134
1135 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1136
1137
1138 # Build modules for kernels 2.6
1139 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1140 #
1141 # Usage:
1142 #       %build_kernel_modules -m <modules> -C <directory>
1143 #
1144 #  remember that proper Makefile is still required
1145 # Options:
1146 #  -m <modules> (required) -- comma-separated list of modules to save,
1147 #               without .ko extension, may be placed in subdirectory
1148 #  -C <directory> -- change to <directory> before doing anything
1149 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1150 #  -c -- do not execute make clean
1151 #  <additional arguments> -- all additional arguments will be passed to
1152 #               make modules
1153 #
1154 # Additional patching supported via here document. Try:
1155 #       %build_kernel_modules -m module <<'EOF'
1156 #       your patch script here
1157 #       EOF
1158 # Don't use it unless patching depends on config options.
1159
1160 # Developer note: don't touch it unless you know how to handle '\'.
1161 # - \ in script expands to nothing
1162 # - \\\ in script expands to \
1163 # - \\\ inside definition expands to noting
1164 # - \\\\\\\ inside definition expands to \
1165 # - in last line \ has to touch arguments so arguments passing
1166 #   in new lines (using \) will be supported
1167
1168 %build_kernel_modules(p:P:m:C:c)                                                                        \
1169 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1170                                                                                                                                         \
1171 %define Opts                                                                                                            \\\\\\\
1172 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1173         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1174         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1175         %else                                                                                                                   \\\
1176         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1177         %endif                                                                                                                  \\\
1178 %else                                                                                                                           \\\
1179         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1180 %endif                                                                                                                          \
1181 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1182                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1183                                                                                                                                         \
1184 %{?-C:cd %{-C*}}                                                                                                        \
1185 compile() {                                                                                                                     \
1186         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1187         set -e -x                                                                                                               \
1188                                                                                                                                         \
1189 for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}; do \
1190         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1191                                                                                                                                         \
1192         rm -rf o                                                                                                                \
1193         install -d o/include/linux                                                                              \
1194         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1195         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1196         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1197 %ifarch ppc ppc64                                                                                                       \
1198         install -d o/include/asm                                                                                \
1199         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -sf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm    \
1200         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -snf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1201 %else                                                                                                                           \
1202         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1203 %endif                                                                                                                          \
1204                                                                                                                                         \
1205         set +x                                                                                                                  \
1206         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1207         set -x                                                                                                                  \
1208                                                                                                                                         \
1209         %if %{with dist_kernel}                                                                                 \
1210                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1211                         %{-p*} %{-P*}                                                                                   \\\
1212                         %{MakeOpts}                                                                                             \
1213         %else                                                                                                                   \
1214                 install -d o/include/config                                                                     \
1215                 touch o/include/config/MARKER                                                           \
1216                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1217         %endif                                                                                                                  \
1218                                                                                                                                         \
1219         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1220                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1221                 M=$PWD %{MakeOpts}}                                                                                     \
1222         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1223                 ${1+"$@"}                                                                                                       \\\
1224                 M=$PWD %{MakeOpts}                                                                                      \
1225                                                                                                                                         \
1226         for MODULE in {%{-m*},}; do                                                                             \
1227                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1228         done                                                                                                                    \
1229 done                                                                                                                            \
1230 %{?-C:cd -}                                                                                                                     \
1231 }                                                                                                                                       \
1232 compile %{*}\
1233 %{nil}
1234
1235
1236 # Install kernel modules built by %build_kernel_modules
1237 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1238 #
1239 # Usage:
1240 #       %install_kernel_modules -m <modules> -d <directory>
1241 #
1242 # Options:
1243 #  -m <modules> (required) -- comma-separated list of modules to install,
1244 #               without .ko extension, may be placed in subdirectory
1245 #  -d <directory> (required) -- in what subdirectory modules should be
1246 #               installed (eg. misc, kernel/drivers/net)
1247 #  -s <suffix> -- suffix to use when installing modules, useful when module
1248 #               with same name exists in kernel already
1249 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1250 #               for definig aliases, only useful with -s
1251
1252 %install_kernel_modules(m:d:s:n:)                                                                       \
1253 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1254 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1255 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1256                                                                                                                                         \
1257 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1258 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1259                                                                                                                                         \
1260 install -d %{KernelD}{,smp}/%{-d*}                                                                      \
1261 %{?-s:install -d %{ModprobeD}{,smp}}                                                            \
1262                                                                                                                                         \
1263 for MODULE in {%{-m*},}; do                                                                                     \
1264         [ -n "${MODULE}" ] || continue                                                                  \
1265         MNAME=${MODULE##*/}                                                                                             \
1266         install ${MODULE}-%{?with_dist_kernel:up}%{!?with_dist_kernel:nondist}.ko \\\
1267                 %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                                      \
1268         %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
1269                 >> %{ModprobeD}/%{-n*}.conf}                                                            \
1270     %if %{with smp} && %{with dist_kernel}                                                      \
1271         install ${MODULE}-smp.ko                                                                                \\\
1272                 %{KernelD}smp/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                           \
1273         %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
1274                 >> %{ModprobeD}smp/%{-n*}.conf}                                                         \
1275     %endif                                                                                                                      \
1276 done                                                                                                                            \
1277 %{nil}
1278
1279 # patchset macros
1280 # Author: Elan Ruusamäe <glen@pld-linux.org>
1281 #
1282 # Usage:
1283 #   %patchset_source -f <seq(1) format> <start> [<end>]
1284 #   %patchset_patch <start> [<end>]
1285 #
1286 # If <end> is omited, it is assumed to be <start>.
1287 #
1288 # For example in preamble:
1289 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1290 # and in %prep:
1291 #  %patchset_patch 33 44
1292
1293 # generate SourceX urls from range START STOP
1294 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1295 # The sources start from 10000
1296 %patchset_source(f:b:) %(
1297         base=%{-b*}%{!-b*:10000};
1298         start=$(expr $base + %1);
1299         end=$(expr $base + %{?2}%{!?2:%{1}});
1300         # we need to call seq twice as it doesn't allow two formats
1301         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1302         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1303         paste %{tmpdir}/__ps{1,2};
1304         rm -f %{tmpdir}/__ps{1,2};
1305 ) \
1306 %{nil}
1307
1308 # apply sources from %patchset_source
1309 # -p specify -pX for %patch line
1310 # -b base offset: defaults to 10000
1311 %patchset_patch(f:p:b:) %(
1312         base=%{-b*}%{!-b*:10000};
1313         start=$(expr $base + %1);
1314         end=$(expr $base + %{?2}%{!?2:%{1}});
1315         echo ": patchset_patch %1%{?2: to %2}";
1316         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1317 ) \
1318 %{nil}
1319
1320 # browser plugins v2
1321 # Author: Elan Ruusamäe <glen@pld-linux.org>
1322 #
1323 # Usage:
1324 #       %browser_plugins_add_browser <name> -p <plugindir>
1325 #
1326 #  <name> (required) -- name of the browser. usually %{name}.
1327 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1328 #
1329 # Example:
1330 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1331
1332 %_browserpluginsconfdir         /etc/browser-plugins
1333 %_browserpluginsdir                     %{_libdir}/browser-plugins
1334 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1335
1336 %browser_plugins_add_browser(p:b:) \
1337         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1338         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/%1.%{_target_base_arch} \
1339         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/%1.%{_target_base_arch}.blacklist \
1340         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1341         %{-b:cat >> $blacklist_file %{-b*}} \
1342 %{nil}
1343
1344 # vim:ts=4 sw=4 noet syn=spec
This page took 0.1172 seconds and 3 git commands to generate.